/**************************************************************************
Receive.c
A7 Engineering, 2004

This program is used with RCM3000, RCM3100, RCM3200, RCM3300, and
RCM3400 series controllers with an EmbeddedBlue eb506 radio module.

Description
===========
This sample simply echos characters received from the eb506 Bluetooth
radio to the debug port.

Instructions
============
1. Verify that the eb506 is configured to use serial port F through
    jumpers J1 and J2.
2. Compile and run this program.

**************************************************************************/
#use a7eng_eb506.lib
#class auto

#define BAUD_RATE 9600L

void main()
{
  auto char szPortFData;
  auto int nDataAvailableOnF;

  // Open the serial port for communications and initialize the eb506
  serFopen(BAUD_RATE);
  a7_serFeb506Init();

  while(1)
  {
    // Read data from eb506 and echo it to the debug port
    nDataAvailableOnF = serFrdUsed();
    if(nDataAvailableOnF > 0)
    {
      serFread(&szPortFData, 1, 10);
      printf("%c", szPortFData);
    }
  }
  serFclose();
}