// PPCRxFromEBDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PPCRxFromEB.h"
#include "PPCRxFromEBDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPCRxFromEBDlg dialog

CPPCRxFromEBDlg::CPPCRxFromEBDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPPCRxFromEBDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPPCRxFromEBDlg)
	m_nComPort = -1;
	m_szRxData = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPPCRxFromEBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPCRxFromEBDlg)
	DDX_Control(pDX, IDC_ED_DATA, m_DataCtrl);
	DDX_Control(pDX, IDC_COM_PORT, m_ComPortCtrl);
	DDX_Control(pDX, IDC_BN_DISCONNECT, m_DisconnectCtrl);
	DDX_Control(pDX, IDC_BN_CONNECT, m_ConnectCtrl);
	DDX_CBIndex(pDX, IDC_COM_PORT, m_nComPort);
	DDX_Text(pDX, IDC_ED_DATA, m_szRxData);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPPCRxFromEBDlg, CDialog)
	//{{AFX_MSG_MAP(CPPCRxFromEBDlg)
	ON_BN_CLICKED(IDC_BN_CONNECT, OnBnConnect)
	ON_BN_CLICKED(IDC_BN_DISCONNECT, OnBnDisconnect)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPCRxFromEBDlg message handlers

BOOL CPPCRxFromEBDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// Select first entry in the Com Port dropdown.
	m_ComPortCtrl.SetCurSel(0);

	// Enable Connect button.
	m_ConnectCtrl.EnableWindow(TRUE);

	// Disable Disconnect button.
	m_DisconnectCtrl.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CPPCRxFromEBDlg::OnBnConnect() 
{
	TCHAR	szComPort[6];

	// Update variables with dialog data.
	UpdateData(TRUE);

	// m_nComPort holds the zero-based index to the entry.
	_stprintf(szComPort, _T("COM%d:"), m_nComPort + 1);

	// Open the COM port.
	m_hComPort = CreateFile(szComPort,
							GENERIC_READ,
							0,
							NULL,
							OPEN_EXISTING,
							0,
							0);
	if (INVALID_HANDLE_VALUE != m_hComPort)
	{
		COMMTIMEOUTS	commtimeouts;

		// Get the current timeouts.
		GetCommTimeouts(m_hComPort,
						&commtimeouts);

		// Set the total timeout to 50 ms.
		commtimeouts.ReadTotalTimeoutConstant = 50;
		SetCommTimeouts(m_hComPort,
						&commtimeouts);

		// Disable Connect button.
		m_ConnectCtrl.EnableWindow(FALSE);

		// Enable Disconnect button
		m_DisconnectCtrl.EnableWindow(TRUE);

		// Create a timer event to get the characters from the COM port.
		m_nTimer = SetTimer(1, 25, 0);
	}
	else
	{
		AfxMessageBox(_T("Error openning COM port."), MB_OK);
	}
}

void CPPCRxFromEBDlg::OnBnDisconnect() 
{
	// Close the COM port.
	CloseHandle(m_hComPort);
	m_hComPort = INVALID_HANDLE_VALUE;

	// Stop the timer events.
	KillTimer(m_nTimer);

	// Enable Connect button.
	m_ConnectCtrl.EnableWindow(TRUE);

	// Disable Disconnect button.
	m_DisconnectCtrl.EnableWindow(FALSE);	
}

void CPPCRxFromEBDlg::OnTimer(UINT nIDEvent) 
{
	DWORD	dwNumberOfBytesRead;
	char	szAsciiData[128];
	memset(szAsciiData, 0, sizeof(szAsciiData));

	ReadFile(m_hComPort,
			 szAsciiData,
			 sizeof(szAsciiData),
			 &dwNumberOfBytesRead,
			 NULL);
	if (0 != dwNumberOfBytesRead)
	{
		TCHAR	chUnicodeData;

		// Update our variable associated with the control.
		UpdateData(TRUE);

		// This is an inneficient, but simple way of handling the
		// conversion of \r to \r\n for display.
		for(DWORD dwCounter = 0; dwCounter < dwNumberOfBytesRead; dwCounter++)
		{
			if ('\r' == szAsciiData[dwCounter])
			{
				m_szRxData += _T("\r\n");
			}
			else
			{
				// Convert ANSII character to Unicode character.
				mbstowcs(	&chUnicodeData,
							&szAsciiData[dwCounter],
							1);
				m_szRxData += chUnicodeData;
			}
		}

		// Update the control.
		UpdateData(FALSE);
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CPPCRxFromEBDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	if (INVALID_HANDLE_VALUE != m_hComPort)
	{
		// Close the COM port.
		CloseHandle(m_hComPort);
		m_hComPort = INVALID_HANDLE_VALUE;
	}
}
