// PPCTxToEBDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PPCTxToEB.h"
#include "PPCTxToEBDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPCTxToEBDlg dialog

CPPCTxToEBDlg::CPPCTxToEBDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPPCTxToEBDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPPCTxToEBDlg)
	m_nComPort = -1;
	m_csTextToTransmit = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPPCTxToEBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPCTxToEBDlg)
	DDX_Control(pDX, IDC_ED_SEND_BUFFER, m_SentBufferCtrl);
	DDX_Control(pDX, IDC_BN_CLEAR, m_ClearCtrl);
	DDX_Control(pDX, IDC_BN_SET_HELLO_WORLD, m_SetHelloWorldCtrl);
	DDX_Control(pDX, IDC_COM_PORT, m_ComPortCtrl);
	DDX_Control(pDX, IDC_BN_SEND, m_SendCtrl);
	DDX_Control(pDX, IDC_BN_DISCONNECT, m_DisconnectCtrl);
	DDX_Control(pDX, IDC_BN_CONNECT, m_ConnectCtrl);
	DDX_CBIndex(pDX, IDC_COM_PORT, m_nComPort);
	DDX_Text(pDX, IDC_ED_SEND_BUFFER, m_csTextToTransmit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPPCTxToEBDlg, CDialog)
	//{{AFX_MSG_MAP(CPPCTxToEBDlg)
	ON_BN_CLICKED(IDC_BN_CONNECT, OnBnConnect)
	ON_BN_CLICKED(IDC_BN_DISCONNECT, OnBnDisconnect)
	ON_BN_CLICKED(IDC_BN_SEND, OnBnSend)
	ON_BN_CLICKED(IDC_BN_CLEAR, OnBnClear)
	ON_BN_CLICKED(IDC_BN_SET_HELLO_WORLD, OnBnSetHelloWorld)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPCTxToEBDlg message handlers

BOOL CPPCTxToEBDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// Select first entry in the Com Port dropdown.
	m_ComPortCtrl.SetCurSel(0);

	// Enable Connect button.
	m_ConnectCtrl.EnableWindow(TRUE);

	// Disable Disconnect button.
	m_DisconnectCtrl.EnableWindow(FALSE);

	// Disable Send button.
	m_SendCtrl.EnableWindow(FALSE);

	// Disable Clear button
	m_ClearCtrl.EnableWindow(FALSE);

	// Disable Set Hello World button
	m_SetHelloWorldCtrl.EnableWindow(FALSE);

	// Disable send string edit box
	m_SentBufferCtrl.EnableWindow(FALSE);

	// Clear the text to send string
	m_csTextToTransmit.Empty();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CPPCTxToEBDlg::OnBnConnect() 
{
	TCHAR	szComPort[6];

	// Update variables with dialog data.
	UpdateData(TRUE);

	// m_nComPort holds the zero-based index to the entry.
	// sprintf
	_stprintf(szComPort, _T("COM%d:"), m_nComPort + 1);

	// Open the COM port.
	m_hComPort = CreateFile(szComPort,
							GENERIC_WRITE,
							0,
							NULL,
							OPEN_EXISTING,
							0,
							0);
	if (INVALID_HANDLE_VALUE != m_hComPort)
	{
		// Disable Connect button.
		m_ConnectCtrl.EnableWindow(FALSE);

		// Enable Disconnect button
		m_DisconnectCtrl.EnableWindow(TRUE);

		// Enable Send button.
		m_SendCtrl.EnableWindow(TRUE);

		// Enable the Clear button
		m_ClearCtrl.EnableWindow(TRUE);
		
		// Enable the send string edit box and set the focus
		m_SentBufferCtrl.EnableWindow(TRUE);
		m_SentBufferCtrl.SetFocus();

		// Enable the Set Hello World button
		m_SetHelloWorldCtrl.EnableWindow(TRUE);

		// Show the currently active software-based input panel window
		SipShowIM(SIPF_ON);
	}
	else
	{
		AfxMessageBox(_T("Error openning COM port."), MB_OK);
	}	
}

void CPPCTxToEBDlg::OnBnDisconnect() 
{
	// Close the COM port.
	CloseHandle(m_hComPort);

	// Enable Connect button.
	m_ConnectCtrl.EnableWindow(TRUE);

	// Disable Disconnect button.
	m_DisconnectCtrl.EnableWindow(FALSE);

	// Disable Send button.
	m_SendCtrl.EnableWindow(FALSE);

	// Disable the Clear button
	m_ClearCtrl.EnableWindow(FALSE);

	// Disable the send string edit box
	m_SentBufferCtrl.EnableWindow(FALSE);

	// Disable the Set Hello World button
	m_SetHelloWorldCtrl.EnableWindow(FALSE);
}

void CPPCTxToEBDlg::OnBnSend() 
{
	DWORD	dwNumBytesWritten;
	
	// Allocate a buffer to hold a single byte version of the string
	char szTextToTransmit[256];
	memset(szTextToTransmit, 0, sizeof(szTextToTransmit));

	// Get the text from the windows control into the CString
	UpdateData(TRUE);

	// Append carriage return and linefeed
	m_csTextToTransmit += _T("\r");

	// Convert the string to single byte characters
	WideCharToMultiByte( CP_ACP, 0, m_csTextToTransmit, -1,
        szTextToTransmit, 256, NULL, NULL );

	// Send the text out the COM port.
	WriteFile(	m_hComPort, 
				szTextToTransmit,
				strlen(szTextToTransmit),
				&dwNumBytesWritten,
				NULL);
}

void CPPCTxToEBDlg::OnBnClear() 
{
	// Clear the transmit string
	m_csTextToTransmit.Empty();
	UpdateData(FALSE);

	// Put the focus back to the edit box
	m_SentBufferCtrl.SetFocus();
}

void CPPCTxToEBDlg::OnBnSetHelloWorld() 
{
	// Set the text to send string to "Hello World"
	m_csTextToTransmit = _T("Hello World");
	UpdateData(FALSE);
}
